import WalkupScanDestination from "./WalkupScanDestination";
import WalkupScanToCompDestination from "./WalkupScanToCompDestination";
import EventTable from "./EventTable";
import Job from "./Job";
import ScanStatus from "./ScanStatus";
import WalkupScanDestinations from "./WalkupScanDestinations";
import WalkupScanToCompDestinations from "./WalkupScanToCompDestinations";
import ScanJobSettings from "./ScanJobSettings";
import Destination from "./Destination";
export default class HPApi {
    static setPrinterIP(ip: string): void;
    static getWalkupScanDestinations(): Promise<WalkupScanDestinations>;
    static getWalkupScanToCompDestinations(): Promise<WalkupScanToCompDestinations>;
    static getWalkupScanToCompCaps(): Promise<boolean>;
    static removeDestination(walkupScanDestination: WalkupScanDestination): Promise<boolean>;
    static registerDestination(destination: Destination, toComp: Boolean): Promise<any>;
    static getEvents(etag?: string, timeout?: number): Promise<{
        etag: string;
        eventTable: EventTable;
    }>;
    static placeETagHeader(etag: string, headers: object): object;
    static appendTimeout(timeout: number | null | undefined, url: string): string;
    static getDestination(destinationURL: string): Promise<WalkupScanDestination | WalkupScanToCompDestination>;
    static getScanStatus(): Promise<ScanStatus>;
    static delay(t: number): Promise<unknown>;
    static postJob(job: ScanJobSettings): Promise<any>;
    /**
     * @param jobURL
     * @return {Promise<Job|*>}
     */
    static getJob(jobURL: string): Promise<Job>;
    static downloadPage(binaryURL: string, destination: string): Promise<string>;
}
