"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var WalkupScanDestination_1 = __importDefault(require("./WalkupScanDestination"));
var WalkupScanToCompDestination_1 = __importDefault(require("./WalkupScanToCompDestination"));
var util_1 = __importDefault(require("util"));
var fs_1 = __importDefault(require("fs"));
var axios_1 = __importDefault(require("axios"));
var url_1 = __importDefault(require("url"));
var xml2js_1 = __importDefault(require("xml2js"));
var EventTable_1 = __importDefault(require("./EventTable"));
var Job_1 = __importDefault(require("./Job"));
var ScanStatus_1 = __importDefault(require("./ScanStatus"));
var WalkupScanDestinations_1 = __importDefault(require("./WalkupScanDestinations"));
var WalkupScanToCompDestinations_1 = __importDefault(require("./WalkupScanToCompDestinations"));
var parser = new xml2js_1.default.Parser();
var parseString = util_1.default.promisify(parser.parseString);
var printerIP = "192.168.1.11";
var HPApi = /** @class */ (function () {
    function HPApi() {
    }
    HPApi.setPrinterIP = function (ip) {
        printerIP = ip;
    };
    HPApi.getWalkupScanDestinations = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            baseURL: "http://" + printerIP,
                            url: "/WalkupScan/WalkupScanDestinations",
                            method: "GET",
                            responseType: "text",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 2];
                        throw new Error(response.statusText);
                    case 2: return [4 /*yield*/, parseString(response.data)];
                    case 3:
                        parsed = (_a.sent());
                        return [2 /*return*/, new WalkupScanDestinations_1.default(parsed)];
                }
            });
        });
    };
    HPApi.getWalkupScanToCompDestinations = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            baseURL: "http://" + printerIP,
                            url: "/WalkupScanToComp/WalkupScanToCompDestinations",
                            method: "GET",
                            responseType: "text",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 2];
                        throw new Error(response.statusText);
                    case 2: return [4 /*yield*/, parseString(response.data)];
                    case 3:
                        parsed = (_a.sent());
                        return [2 /*return*/, new WalkupScanToCompDestinations_1.default(parsed)];
                }
            });
        });
    };
    HPApi.getWalkupScanToCompCaps = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            baseURL: "http://" + printerIP,
                            url: "/WalkupScanToComp/WalkupScanToCompCaps",
                            method: "GET",
                            responseType: "text",
                        }).then(function (response) { return response.status == 200; }, function () { return false; })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    HPApi.removeDestination = function (walkupScanDestination) {
        return __awaiter(this, void 0, void 0, function () {
            var urlInfo, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        urlInfo = url_1.default.parse(walkupScanDestination.resourceURI);
                        if (urlInfo.pathname === null) {
                            throw new Error("invalid walkupScanDestination.resourceURI: " + walkupScanDestination.resourceURI);
                        }
                        return [4 /*yield*/, axios_1.default({
                                baseURL: "http://" + printerIP,
                                url: urlInfo.pathname,
                                method: "DELETE",
                                responseType: "text",
                            })];
                    case 1:
                        response = _a.sent();
                        if (response.status === 204) {
                            return [2 /*return*/, true];
                        }
                        else {
                            throw response;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    HPApi.registerDestination = function (destination, toComp) {
        return __awaiter(this, void 0, void 0, function () {
            var xml, url, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, destination.toXML()];
                    case 1:
                        xml = _a.sent();
                        url = "/WalkupScan/WalkupScanDestinations";
                        if (toComp) {
                            url = "/WalkupScanToComp/WalkupScanToCompDestinations";
                        }
                        return [4 /*yield*/, axios_1.default({
                                baseURL: "http://" + printerIP,
                                url: url,
                                method: "POST",
                                headers: { "Content-Type": "text/xml" },
                                data: xml,
                                responseType: "text",
                            })];
                    case 2:
                        response = _a.sent();
                        if (response.status === 201) {
                            return [2 /*return*/, response.headers.location];
                        }
                        else {
                            throw response;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    HPApi.getEvents = function (etag, timeout) {
        if (etag === void 0) { etag = ""; }
        if (timeout === void 0) { timeout = 0; }
        return __awaiter(this, void 0, void 0, function () {
            var url, headers, response, error_1, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.appendTimeout(timeout, "/EventMgmt/EventTable");
                        headers = this.placeETagHeader(etag, {});
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default({
                                baseURL: "http://" + printerIP,
                                url: url,
                                method: "GET",
                                responseType: "text",
                                headers: headers,
                            })];
                    case 2:
                        response = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        response = error_1.response;
                        if (response.status === 304) {
                            return [2 /*return*/, {
                                    etag: etag,
                                    eventTable: new EventTable_1.default({}),
                                }];
                        }
                        throw error_1;
                    case 4: return [4 /*yield*/, parseString(response.data)];
                    case 5:
                        parsed = _a.sent();
                        return [2 /*return*/, {
                                etag: response.headers["etag"],
                                eventTable: new EventTable_1.default(parsed),
                            }];
                }
            });
        });
    };
    HPApi.placeETagHeader = function (etag, headers) {
        if (etag !== "") {
            headers = {
                "If-None-Match": etag,
            };
        }
        return headers;
    };
    HPApi.appendTimeout = function (timeout, url) {
        if (timeout === void 0) { timeout = null; }
        if (timeout == null) {
            timeout = 1200;
        }
        if (timeout > 0) {
            url += "?timeout=" + timeout;
        }
        return url;
    };
    HPApi.getDestination = function (destinationURL) {
        return __awaiter(this, void 0, void 0, function () {
            var response, parsed, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            baseURL: "http://" + printerIP,
                            url: destinationURL,
                            method: "GET",
                            responseType: "text",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 2];
                        throw response;
                    case 2:
                        if (!destinationURL.includes("WalkupScanToComp")) return [3 /*break*/, 4];
                        return [4 /*yield*/, parseString(response.data)];
                    case 3:
                        parsed = (_a.sent());
                        return [2 /*return*/, new WalkupScanToCompDestination_1.default(parsed)];
                    case 4: return [4 /*yield*/, parseString(response.data)];
                    case 5:
                        parsed = (_a.sent());
                        return [2 /*return*/, new WalkupScanDestination_1.default(parsed)];
                }
            });
        });
    };
    HPApi.getScanStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            baseURL: "http://" + printerIP,
                            url: "/Scan/Status",
                            method: "GET",
                            responseType: "text",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 2];
                        throw response;
                    case 2: return [4 /*yield*/, parseString(response.data)];
                    case 3:
                        parsed = (_a.sent());
                        return [2 /*return*/, new ScanStatus_1.default(parsed)];
                }
            });
        });
    };
    HPApi.delay = function (t) {
        return new Promise(function (resolve) {
            setTimeout(resolve, t);
        });
    };
    HPApi.postJob = function (job) {
        return __awaiter(this, void 0, void 0, function () {
            var xml, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, HPApi.delay(500)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, job.toXML()];
                    case 2:
                        xml = _a.sent();
                        return [4 /*yield*/, axios_1.default({
                                baseURL: "http://" + printerIP + ":8080",
                                url: "/Scan/Jobs",
                                method: "POST",
                                headers: { "Content-Type": "text/xml" },
                                data: xml,
                                responseType: "text",
                            })];
                    case 3:
                        response = _a.sent();
                        if (response.status === 201) {
                            return [2 /*return*/, response.headers.location];
                        }
                        else {
                            throw response;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param jobURL
     * @return {Promise<Job|*>}
     */
    HPApi.getJob = function (jobURL) {
        return __awaiter(this, void 0, void 0, function () {
            var response, parsed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default({
                            url: jobURL,
                            method: "GET",
                            responseType: "text",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!(response.status !== 200)) return [3 /*break*/, 2];
                        throw response;
                    case 2: return [4 /*yield*/, parseString(response.data)];
                    case 3:
                        parsed = (_a.sent());
                        return [2 /*return*/, new Job_1.default(parsed)];
                }
            });
        });
    };
    HPApi.downloadPage = function (binaryURL, destination) {
        return __awaiter(this, void 0, void 0, function () {
            var data, destinationFileStream;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1.default.request({
                            baseURL: "http://" + printerIP + ":8080",
                            url: binaryURL,
                            method: "GET",
                            responseType: "stream",
                        })];
                    case 1:
                        data = (_a.sent()).data;
                        destinationFileStream = fs_1.default.createWriteStream(destination);
                        data.pipe(destinationFileStream);
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                data
                                    .on("end", function () {
                                    resolve(destination);
                                })
                                    .on("error", function (error) { return reject(error); });
                            })];
                }
            });
        });
    };
    return HPApi;
}());
exports.default = HPApi;
//# sourceMappingURL=HPApi.js.map