export interface JobData {
    "j:Job": {
        ScanJob: {
            PreScanPage?: {
                PageState: string[];
                BinaryURL: string[];
                PageNumber: string[];
            }[];
            PostScanPage: {
                PageNumber: string[];
            }[];
        }[];
        "j:JobState": string[];
    };
}
export default class Job {
    private readonly data;
    constructor(data: JobData);
    get currentPageNumber(): string | null;
    get totalPageNumber(): number;
    get jobState(): "Completed" | "Processing" | "ReadyToUpload" | string;
    get pageState(): string;
    get binaryURL(): string | null;
}
