#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var os_1 = __importDefault(require("os"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = __importDefault(require("util"));
var bonjour_1 = __importDefault(require("bonjour"));
var Destination_1 = __importDefault(require("./Destination"));
var ScanJobSettings_1 = __importDefault(require("./ScanJobSettings"));
var HPApi_1 = __importDefault(require("./HPApi"));
function delay(t) {
    return new Promise(function (resolve) {
        setTimeout(resolve, t);
    });
}
function waitForScanEvent(resourceURI) {
    return __awaiter(this, void 0, void 0, function () {
        var eventTable, acceptedScanEvent, currentEtag;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("Start listening for new ScanEvent");
                    return [4 /*yield*/, HPApi_1.default.getEvents()];
                case 1:
                    eventTable = _a.sent();
                    acceptedScanEvent = null;
                    currentEtag = eventTable.etag;
                    _a.label = 2;
                case 2:
                    if (!(acceptedScanEvent == null)) return [3 /*break*/, 4];
                    return [4 /*yield*/, HPApi_1.default.getEvents(currentEtag, 1200)];
                case 3:
                    eventTable = _a.sent();
                    currentEtag = eventTable.etag;
                    acceptedScanEvent = eventTable.eventTable.events.find(function (ev) { return ev.isScanEvent && ev.resourceURI === resourceURI; });
                    return [3 /*break*/, 2];
                case 4: return [2 /*return*/, acceptedScanEvent];
            }
        });
    });
}
function waitPrinterUntilItIsReadyToUploadOrCompleted(jobUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var job, isReadyToUpload;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    job = null;
                    isReadyToUpload = false;
                    _a.label = 1;
                case 1: return [4 /*yield*/, HPApi_1.default.getJob(jobUrl)];
                case 2:
                    job = _a.sent();
                    isReadyToUpload =
                        job.pageState === "ReadyToUpload" || job.jobState === "Completed";
                    return [4 /*yield*/, delay(200)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    if (!isReadyToUpload) return [3 /*break*/, 1];
                    _a.label = 5;
                case 5: return [2 /*return*/, job];
            }
        });
    });
}
function register() {
    return __awaiter(this, void 0, void 0, function () {
        var destination, hostname, toComp, walkupScanDestinations, destinations, walkupScanDestinations, destinations, resourceURI;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    hostname = os_1.default.hostname();
                    return [4 /*yield*/, HPApi_1.default.getWalkupScanToCompCaps()];
                case 1:
                    toComp = _a.sent();
                    if (!toComp) return [3 /*break*/, 3];
                    return [4 /*yield*/, HPApi_1.default.getWalkupScanToCompDestinations()];
                case 2:
                    walkupScanDestinations = _a.sent();
                    destinations = walkupScanDestinations.destinations;
                    console.log("Host destinations fetched:", destinations.map(function (d) { return d.name; }).join(", "));
                    destination = destinations.find(function (x) { return x.name === hostname; });
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, HPApi_1.default.getWalkupScanDestinations()];
                case 4:
                    walkupScanDestinations = _a.sent();
                    destinations = walkupScanDestinations.destinations;
                    console.log("Host destinations fetched:", destinations.map(function (d) { return d.name; }).join(", "));
                    destination = destinations.find(function (x) { return x.name === hostname; });
                    _a.label = 5;
                case 5:
                    if (!destination) return [3 /*break*/, 6];
                    console.log("Re-using existing destination: " + hostname + " - " + destination.resourceURI);
                    resourceURI = destination.resourceURI;
                    return [3 /*break*/, 8];
                case 6: return [4 /*yield*/, HPApi_1.default.registerDestination(new Destination_1.default(hostname, hostname, toComp), toComp)];
                case 7:
                    resourceURI = _a.sent();
                    console.log("New Destination registered: " + hostname + " - " + resourceURI);
                    _a.label = 8;
                case 8: return [2 /*return*/, resourceURI];
            }
        });
    });
}
function getNextFile(folder, currentPageNumber) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, path_1.default.join(folder, "scanPage" + currentPageNumber + ".jpg")];
        });
    });
}
function saveScan(event) {
    return __awaiter(this, void 0, void 0, function () {
        var shortcut, contentType, i, destination, scanStatus, inputSource, scanJobSettings, jobUrl, job, folder, destinationFilePath, filePath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    shortcut = "";
                    contentType = "";
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(shortcut == "")) return [3 /*break*/, 6];
                    return [4 /*yield*/, HPApi_1.default.getDestination(event.resourceURI)];
                case 2:
                    destination = _a.sent();
                    shortcut = destination.shortcut;
                    if (!(shortcut !== "")) return [3 /*break*/, 3];
                    contentType = destination.getContentType();
                    console.log("Selected shortcut: " + shortcut);
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 1000); })];
                case 4:
                    _a.sent(); //wait 1s
                    i += 1;
                    if (i > 20) {
                        return [2 /*return*/];
                    } //prevent endless loop
                    _a.label = 5;
                case 5: return [3 /*break*/, 1];
                case 6: return [4 /*yield*/, HPApi_1.default.getScanStatus()];
                case 7:
                    scanStatus = _a.sent();
                    console.log("Afd is : " + scanStatus.adfState);
                    inputSource = scanStatus.getInputSource();
                    scanJobSettings = new ScanJobSettings_1.default(inputSource, contentType);
                    return [4 /*yield*/, HPApi_1.default.postJob(scanJobSettings)];
                case 8:
                    jobUrl = _a.sent();
                    console.log("New job created:", jobUrl);
                    return [4 /*yield*/, HPApi_1.default.getJob(jobUrl)];
                case 9:
                    job = _a.sent();
                    _a.label = 10;
                case 10:
                    if (!(job.jobState !== "Completed")) return [3 /*break*/, 21];
                    return [4 /*yield*/, waitPrinterUntilItIsReadyToUploadOrCompleted(jobUrl)];
                case 11:
                    job = _a.sent();
                    if (job.jobState == "Completed") {
                        return [3 /*break*/, 10];
                    }
                    if (!(job.jobState === "Processing")) return [3 /*break*/, 18];
                    if (!(job.pageState == "ReadyToUpload" &&
                        job.binaryURL != null &&
                        job.currentPageNumber != null)) return [3 /*break*/, 15];
                    console.log("Ready to download page " + job.currentPageNumber + " at:", job.binaryURL);
                    return [4 /*yield*/, util_1.default.promisify(fs_1.default.mkdtemp)(path_1.default.join(os_1.default.tmpdir(), "scan-to-pc"))];
                case 12:
                    folder = _a.sent();
                    console.log("Target folder: " + folder);
                    return [4 /*yield*/, getNextFile(folder, job.currentPageNumber)];
                case 13:
                    destinationFilePath = _a.sent();
                    return [4 /*yield*/, HPApi_1.default.downloadPage(job.binaryURL, destinationFilePath)];
                case 14:
                    filePath = _a.sent();
                    console.log("Page downloaded to:", filePath);
                    return [3 /*break*/, 17];
                case 15:
                    console.log("Unknown pageState: " + job.pageState);
                    return [4 /*yield*/, delay(200)];
                case 16:
                    _a.sent();
                    _a.label = 17;
                case 17: return [3 /*break*/, 20];
                case 18:
                    console.log("Unknown jobState: " + job.jobState);
                    return [4 /*yield*/, delay(200)];
                case 19:
                    _a.sent();
                    _a.label = 20;
                case 20: return [3 /*break*/, 10];
                case 21:
                    console.log("Job state: " + job.jobState + ", totalPages: " + job.totalPageNumber);
                    return [2 /*return*/];
            }
        });
    });
}
function init() {
    return __awaiter(this, void 0, void 0, function () {
        var keepActive, errorCount, resourceURI, event_1, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    keepActive = true;
                    errorCount = 0;
                    _a.label = 1;
                case 1:
                    if (!keepActive) return [3 /*break*/, 9];
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 6, , 7]);
                    return [4 /*yield*/, register()];
                case 3:
                    resourceURI = _a.sent();
                    console.log("Waiting scan event for:", resourceURI);
                    return [4 /*yield*/, waitForScanEvent(resourceURI)];
                case 4:
                    event_1 = _a.sent();
                    console.log("Scan event captured");
                    return [4 /*yield*/, saveScan(event_1)];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 6:
                    e_1 = _a.sent();
                    errorCount++;
                    console.error(e_1);
                    return [3 /*break*/, 7];
                case 7:
                    if (errorCount === 50) {
                        keepActive = false;
                    }
                    return [4 /*yield*/, delay(1000)];
                case 8:
                    _a.sent();
                    return [3 /*break*/, 1];
                case 9: return [2 /*return*/];
            }
        });
    });
}
function findOfficejetIp() {
    return new Promise(function (resolve) {
        var bonjour = bonjour_1.default();
        console.log("Searching printer...");
        var browser = bonjour.find({
            type: "http",
        }, function (service) {
            console.log(".");
            if (service.name.startsWith("Officejet 6500 E710n-z") && //modify for your printer, i.e. "Deskjet 3520 series"
                service.port === 80 &&
                service.type === "http" &&
                service.addresses != null) {
                browser.stop();
                bonjour.destroy();
                console.log("Found: " + service.name);
                resolve(service.addresses[0]);
            }
        });
        browser.start();
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var ip;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, findOfficejetIp()];
                case 1:
                    ip = _a.sent();
                    HPApi_1.default.setPrinterIP(ip);
                    return [4 /*yield*/, init()];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
main();
//# sourceMappingURL=index.js.map